#include <Adafruit_NeoPixel.h>
#include <Adafruit_GFX.h>
#include <Servo.h>

const uint32_t PIN_BUTTON = 5; 
const uint32_t PIN_EYE_LEFT = 11;
const uint32_t PIN_EYE_RIGHT = 12;
const uint32_t PIN_BOARD_LED = 13;
const uint32_t PIN_NEOPIXEL_BOARD = 8;

#define NUMPIXELS 1

uint32_t RED = Adafruit_NeoPixel::Color(255, 0, 0);
uint32_t YELLOW = Adafruit_NeoPixel::Color(255, 150, 0);
uint32_t GREEN = Adafruit_NeoPixel::Color(0, 255, 0);
uint32_t CYAN = Adafruit_NeoPixel::Color(0, 255, 255);
uint32_t BLUE = Adafruit_NeoPixel::Color(0, 0, 255);
uint32_t PURPLE = Adafruit_NeoPixel::Color(180, 0, 255);

Adafruit_NeoPixel eyeLeft(NUMPIXELS, PIN_EYE_LEFT, NEO_GRB + NEO_KHZ800);
Adafruit_NeoPixel eyeRight(NUMPIXELS, PIN_EYE_RIGHT, NEO_GRB + NEO_KHZ800);

int buttonState = 0;         // button status

uint8_t colorIndex = 0;
const uint8_t INDEX_INC = 10;  

uint32_t BuildGreen(uint8_t level)
{
  uint32_t color= Adafruit_NeoPixel::Color(level, 255, level);
  return color;
}

uint32_t BuildRed(uint8_t level)
{
  uint32_t color= Adafruit_NeoPixel::Color(255, level, level);
  return color;
}

void setup() {
  //switch off board led
  pinMode(PIN_BOARD_LED, OUTPUT);
  digitalWrite(PIN_BOARD_LED, LOW);
  //button
  pinMode(PIN_BUTTON, INPUT);
  // left eye
  eyeLeft.begin();
  eyeLeft.setPixelColor(0, CYAN);
  eyeLeft.setBrightness(80);
  eyeLeft.show();   // Send the updated pixel colors to the hardware.
  // right eye
  eyeRight.begin();
  eyeRight.setBrightness(80);
  eyeRight.setPixelColor(0, CYAN);
  eyeRight.show();

  colorIndex = 0;
}

void loop() {
   buttonState = digitalRead(PIN_BUTTON);

   uint32_t currentColor= 0; 
   if(buttonState==HIGH)
   {     
      currentColor= BuildRed(colorIndex);
   }
   else
   {
      currentColor= BuildGreen(colorIndex);
   }
   
   eyeLeft.setPixelColor(0, currentColor);
   eyeRight.setPixelColor(0, currentColor);
   eyeLeft.show();
   eyeRight.show(); 
  
   if((colorIndex+INDEX_INC)<=255)
   {
      colorIndex= colorIndex+INDEX_INC;  
   }
   else 
   {
      colorIndex=0;  
   }
   delay(1000);
}
